/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest
 *
 * The version of the OpenAPI document: 1.0.4
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AccountRestrictionFlagsEnum } from './AccountRestrictionFlagsEnum';
import { NetworkTypeEnum } from './NetworkTypeEnum';
/**
 * Transaction to prevent incoming transactions containing a given set of mosaics.
 * @export
 * @interface AccountMosaicRestrictionTransactionDTO
 */
export interface AccountMosaicRestrictionTransactionDTO {
    /**
     * A number that allows uint 32 values.
     * @type {number}
     * @memberof AccountMosaicRestrictionTransactionDTO
     */
    size: number;
    /**
     * Entity's signature generated by the signer.
     * @type {string}
     * @memberof AccountMosaicRestrictionTransactionDTO
     */
    signature: string;
    /**
     * Public key.
     * @type {string}
     * @memberof AccountMosaicRestrictionTransactionDTO
     */
    signerPublicKey: string;
    /**
     * Entity version.
     * @type {number}
     * @memberof AccountMosaicRestrictionTransactionDTO
     */
    version: number;
    /**
     *
     * @type {NetworkTypeEnum}
     * @memberof AccountMosaicRestrictionTransactionDTO
     */
    network: NetworkTypeEnum;
    /**
     *
     * @type {number}
     * @memberof AccountMosaicRestrictionTransactionDTO
     */
    type: number;
    /**
     * Absolute amount. An amount of 123456789 (absolute) for a mosaic with divisibility 6 means 123.456789 (relative).
     * @type {string}
     * @memberof AccountMosaicRestrictionTransactionDTO
     */
    maxFee: string;
    /**
     * Duration expressed in number of blocks.
     * @type {string}
     * @memberof AccountMosaicRestrictionTransactionDTO
     */
    deadline: string;
    /**
     *
     * @type {AccountRestrictionFlagsEnum}
     * @memberof AccountMosaicRestrictionTransactionDTO
     */
    restrictionFlags: AccountRestrictionFlagsEnum;
    /**
     * Account restriction additions.
     * @type {Array<string>}
     * @memberof AccountMosaicRestrictionTransactionDTO
     */
    restrictionAdditions: Array<string>;
    /**
     * Account restriction deletions.
     * @type {Array<string>}
     * @memberof AccountMosaicRestrictionTransactionDTO
     */
    restrictionDeletions: Array<string>;
}
export declare function AccountMosaicRestrictionTransactionDTOFromJSON(json: any): AccountMosaicRestrictionTransactionDTO;
export declare function AccountMosaicRestrictionTransactionDTOFromJSONTyped(json: any, ignoreDiscriminator: boolean): AccountMosaicRestrictionTransactionDTO;
export declare function AccountMosaicRestrictionTransactionDTOToJSON(value?: AccountMosaicRestrictionTransactionDTO | null): any;
