/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest
 *
 * The version of the OpenAPI document: 1.0.4
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { CosignatureDTO } from './CosignatureDTO';
import { EmbeddedTransactionInfoDTO } from './EmbeddedTransactionInfoDTO';
import { NetworkTypeEnum } from './NetworkTypeEnum';
/**
 * Transaction to combine multiple transactions together.
 * @export
 * @interface AggregateTransactionExtendedDTO
 */
export interface AggregateTransactionExtendedDTO {
    /**
     * A number that allows uint 32 values.
     * @type {number}
     * @memberof AggregateTransactionExtendedDTO
     */
    size: number;
    /**
     * Entity's signature generated by the signer.
     * @type {string}
     * @memberof AggregateTransactionExtendedDTO
     */
    signature: string;
    /**
     * Public key.
     * @type {string}
     * @memberof AggregateTransactionExtendedDTO
     */
    signerPublicKey: string;
    /**
     * Entity version.
     * @type {number}
     * @memberof AggregateTransactionExtendedDTO
     */
    version: number;
    /**
     *
     * @type {NetworkTypeEnum}
     * @memberof AggregateTransactionExtendedDTO
     */
    network: NetworkTypeEnum;
    /**
     *
     * @type {number}
     * @memberof AggregateTransactionExtendedDTO
     */
    type: number;
    /**
     * Absolute amount. An amount of 123456789 (absolute) for a mosaic with divisibility 6 means 123.456789 (relative).
     * @type {string}
     * @memberof AggregateTransactionExtendedDTO
     */
    maxFee: string;
    /**
     * Duration expressed in number of blocks.
     * @type {string}
     * @memberof AggregateTransactionExtendedDTO
     */
    deadline: string;
    /**
     *
     * @type {string}
     * @memberof AggregateTransactionExtendedDTO
     */
    transactionsHash: string;
    /**
     * Array of transaction cosignatures.
     * @type {Array<CosignatureDTO>}
     * @memberof AggregateTransactionExtendedDTO
     */
    cosignatures: Array<CosignatureDTO>;
    /**
     * Array of transactions initiated by different accounts.
     * @type {Array<EmbeddedTransactionInfoDTO>}
     * @memberof AggregateTransactionExtendedDTO
     */
    transactions: Array<EmbeddedTransactionInfoDTO>;
}
export declare function AggregateTransactionExtendedDTOFromJSON(json: any): AggregateTransactionExtendedDTO;
export declare function AggregateTransactionExtendedDTOFromJSONTyped(json: any, ignoreDiscriminator: boolean): AggregateTransactionExtendedDTO;
export declare function AggregateTransactionExtendedDTOToJSON(value?: AggregateTransactionExtendedDTO | null): any;
