/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest
 *
 * The version of the OpenAPI document: 1.0.4
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface MosaicDefinitionTransactionBodyDTO
 */
export interface MosaicDefinitionTransactionBodyDTO {
    /**
     * Mosaic identifier.
     * @type {string}
     * @memberof MosaicDefinitionTransactionBodyDTO
     */
    id: string;
    /**
     * Duration expressed in number of blocks.
     * @type {string}
     * @memberof MosaicDefinitionTransactionBodyDTO
     */
    duration: string;
    /**
     * A number that allows uint 32 values.
     * @type {number}
     * @memberof MosaicDefinitionTransactionBodyDTO
     */
    nonce: number;
    /**
     * - 0x00 (none) - No flags present.
     * - 0x01 (supplyMutable) - Mosaic supports supply changes even when mosaic owner owns partial supply.
     * - 0x02 (transferable) - Mosaic supports transfers between arbitrary accounts. When not set, mosaic can only be transferred to and from mosaic owner.
     * - 0x04 (restrictable) - Mosaic supports custom restrictions configured by mosaic owner.
     * - 0x08 (revokable) - Mosaic allows creator to revoke balances from another user.
     * @type {number}
     * @memberof MosaicDefinitionTransactionBodyDTO
     */
    flags: number;
    /**
     * Determines up to what decimal place the mosaic can be divided.
     * Divisibility of 3 means that a mosaic can be divided into smallest parts of 0.001 mosaics.
     * The divisibility must be in the range of 0 and 6.
     * @type {number}
     * @memberof MosaicDefinitionTransactionBodyDTO
     */
    divisibility: number;
}
export declare function MosaicDefinitionTransactionBodyDTOFromJSON(json: any): MosaicDefinitionTransactionBodyDTO;
export declare function MosaicDefinitionTransactionBodyDTOFromJSONTyped(json: any, ignoreDiscriminator: boolean): MosaicDefinitionTransactionBodyDTO;
export declare function MosaicDefinitionTransactionBodyDTOToJSON(value?: MosaicDefinitionTransactionBodyDTO | null): any;
