/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest
 *
 * The version of the OpenAPI document: 1.0.4
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface NodeInfoDTO
 */
export interface NodeInfoDTO {
    /**
     * Version of the application.
     * @type {number}
     * @memberof NodeInfoDTO
     */
    version: number;
    /**
     * Public key.
     * @type {string}
     * @memberof NodeInfoDTO
     */
    publicKey: string;
    /**
     *
     * @type {string}
     * @memberof NodeInfoDTO
     */
    networkGenerationHashSeed: string;
    /**
     * A number that defines the different roles the node provides. Possible roles are:
     * * 1 - Peer node.
     * * 2 - Api node.
     * * 4 - Voting node.
     * * 64 - IPv4 compatible node
     * * 128 - IPv6 compatible node.
     *
     * The values are bitwise added together, Examples:
     * 1 = Just Peer.
     * 2 = Just Api.
     * 3 = Peer and Api node.
     * 7 = Peer, Api and Voting node.
     * 65 = IPv4 and Peer node.
     * @type {number}
     * @memberof NodeInfoDTO
     */
    roles: number;
    /**
     * Port used for the communication.
     * @type {number}
     * @memberof NodeInfoDTO
     */
    port: number;
    /**
     *
     * @type {number}
     * @memberof NodeInfoDTO
     */
    networkIdentifier: number;
    /**
     * Node friendly name.
     * @type {string}
     * @memberof NodeInfoDTO
     */
    friendlyName: string;
    /**
     * Node IP address.
     * @type {string}
     * @memberof NodeInfoDTO
     */
    host: string;
    /**
     * Public key.
     * @type {string}
     * @memberof NodeInfoDTO
     */
    nodePublicKey?: string;
}
export declare function NodeInfoDTOFromJSON(json: any): NodeInfoDTO;
export declare function NodeInfoDTOFromJSONTyped(json: any, ignoreDiscriminator: boolean): NodeInfoDTO;
export declare function NodeInfoDTOToJSON(value?: NodeInfoDTO | null): any;
