/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest
 *
 * The version of the OpenAPI document: 1.0.4
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { LockHashAlgorithmEnum } from './LockHashAlgorithmEnum';
import { NetworkTypeEnum } from './NetworkTypeEnum';
/**
 * Transaction to reveal a proof.
 * @export
 * @interface SecretProofTransactionDTO
 */
export interface SecretProofTransactionDTO {
    /**
     * A number that allows uint 32 values.
     * @type {number}
     * @memberof SecretProofTransactionDTO
     */
    size: number;
    /**
     * Entity's signature generated by the signer.
     * @type {string}
     * @memberof SecretProofTransactionDTO
     */
    signature: string;
    /**
     * Public key.
     * @type {string}
     * @memberof SecretProofTransactionDTO
     */
    signerPublicKey: string;
    /**
     * Entity version.
     * @type {number}
     * @memberof SecretProofTransactionDTO
     */
    version: number;
    /**
     *
     * @type {NetworkTypeEnum}
     * @memberof SecretProofTransactionDTO
     */
    network: NetworkTypeEnum;
    /**
     *
     * @type {number}
     * @memberof SecretProofTransactionDTO
     */
    type: number;
    /**
     * Absolute amount. An amount of 123456789 (absolute) for a mosaic with divisibility 6 means 123.456789 (relative).
     * @type {string}
     * @memberof SecretProofTransactionDTO
     */
    maxFee: string;
    /**
     * Duration expressed in number of blocks.
     * @type {string}
     * @memberof SecretProofTransactionDTO
     */
    deadline: string;
    /**
     * Address expressed in Base32 format. If the bit 0 of byte 0 is not set (like in 0x90), then it is a
     * regular address. Example: TAOXUJOTTW3W5XTBQMQEX3SQNA6MCUVGXLXR3TA.
     * Otherwise (e.g. 0x91) it represents a namespace id which starts at byte 1. Example: THBIMC3THGH5RUYAAAAAAAAAAAAAAAAAAAAAAAA
     * @type {string}
     * @memberof SecretProofTransactionDTO
     */
    recipientAddress: string;
    /**
     *
     * @type {string}
     * @memberof SecretProofTransactionDTO
     */
    secret: string;
    /**
     *
     * @type {LockHashAlgorithmEnum}
     * @memberof SecretProofTransactionDTO
     */
    hashAlgorithm: LockHashAlgorithmEnum;
    /**
     * Original random set of bytes.
     * @type {string}
     * @memberof SecretProofTransactionDTO
     */
    proof: string;
}
export declare function SecretProofTransactionDTOFromJSON(json: any): SecretProofTransactionDTO;
export declare function SecretProofTransactionDTOFromJSONTyped(json: any, ignoreDiscriminator: boolean): SecretProofTransactionDTO;
export declare function SecretProofTransactionDTOToJSON(value?: SecretProofTransactionDTO | null): any;
