/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest
 *
 * The version of the OpenAPI document: 1.0.4
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import { MerkleStateInfoDTO, MosaicRestrictionDTO, MosaicRestrictionEntryTypeEnum, MosaicRestrictionsPage, Order } from '../models';
export interface GetMosaicRestrictionsRequest {
    compositeHash: string;
}
export interface GetMosaicRestrictionsMerkleRequest {
    compositeHash: string;
}
export interface SearchMosaicRestrictionsRequest {
    mosaicId?: string;
    entryType?: MosaicRestrictionEntryTypeEnum;
    targetAddress?: string;
    pageSize?: number;
    pageNumber?: number;
    offset?: string;
    order?: Order;
}
/**
 *
 */
export declare class RestrictionMosaicRoutesApi extends runtime.BaseAPI {
    /**
     * Returns the mosaic restrictions for a composite hash.
     * Get the mosaic restrictions
     */
    getMosaicRestrictionsRaw(requestParameters: GetMosaicRestrictionsRequest, initOverrides?: RequestInit | runtime.InitOverideFunction): Promise<runtime.ApiResponse<MosaicRestrictionDTO>>;
    /**
     * Returns the mosaic restrictions for a composite hash.
     * Get the mosaic restrictions
     */
    getMosaicRestrictions(requestParameters: GetMosaicRestrictionsRequest, initOverrides?: RequestInit | runtime.InitOverideFunction): Promise<MosaicRestrictionDTO>;
    /**
     * Returns the mosaic restrictions merkle for a given composite hash.
     * Get the mosaic restrictions merkle
     */
    getMosaicRestrictionsMerkleRaw(requestParameters: GetMosaicRestrictionsMerkleRequest, initOverrides?: RequestInit | runtime.InitOverideFunction): Promise<runtime.ApiResponse<MerkleStateInfoDTO>>;
    /**
     * Returns the mosaic restrictions merkle for a given composite hash.
     * Get the mosaic restrictions merkle
     */
    getMosaicRestrictionsMerkle(requestParameters: GetMosaicRestrictionsMerkleRequest, initOverrides?: RequestInit | runtime.InitOverideFunction): Promise<MerkleStateInfoDTO>;
    /**
     * Returns an array of mosaic restrictions.
     * Search mosaic restrictions
     */
    searchMosaicRestrictionsRaw(requestParameters: SearchMosaicRestrictionsRequest, initOverrides?: RequestInit | runtime.InitOverideFunction): Promise<runtime.ApiResponse<MosaicRestrictionsPage>>;
    /**
     * Returns an array of mosaic restrictions.
     * Search mosaic restrictions
     */
    searchMosaicRestrictions(requestParameters?: SearchMosaicRestrictionsRequest, initOverrides?: RequestInit | runtime.InitOverideFunction): Promise<MosaicRestrictionsPage>;
}
