/* tslint:disable */
/* eslint-disable */
/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest
 *
 * The version of the OpenAPI document: 1.0.4
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import { MerkleStateInfoDTOFromJSON, MosaicRestrictionDTOFromJSON, MosaicRestrictionsPageFromJSON, } from '../models';
/**
 *
 */
export class RestrictionMosaicRoutesApi extends runtime.BaseAPI {
    /**
     * Returns the mosaic restrictions for a composite hash.
     * Get the mosaic restrictions
     */
    async getMosaicRestrictionsRaw(requestParameters, initOverrides) {
        if (requestParameters.compositeHash === null || requestParameters.compositeHash === undefined) {
            throw new runtime.RequiredError('compositeHash', 'Required parameter requestParameters.compositeHash was null or undefined when calling getMosaicRestrictions.');
        }
        const queryParameters = {};
        const headerParameters = {};
        const response = await this.request({
            path: `/restrictions/mosaic/{compositeHash}`.replace(`{${"compositeHash"}}`, encodeURIComponent(String(requestParameters.compositeHash))),
            method: 'GET',
            headers: headerParameters,
            query: queryParameters,
        }, initOverrides);
        return new runtime.JSONApiResponse(response, (jsonValue) => MosaicRestrictionDTOFromJSON(jsonValue));
    }
    /**
     * Returns the mosaic restrictions for a composite hash.
     * Get the mosaic restrictions
     */
    async getMosaicRestrictions(requestParameters, initOverrides) {
        const response = await this.getMosaicRestrictionsRaw(requestParameters, initOverrides);
        return await response.value();
    }
    /**
     * Returns the mosaic restrictions merkle for a given composite hash.
     * Get the mosaic restrictions merkle
     */
    async getMosaicRestrictionsMerkleRaw(requestParameters, initOverrides) {
        if (requestParameters.compositeHash === null || requestParameters.compositeHash === undefined) {
            throw new runtime.RequiredError('compositeHash', 'Required parameter requestParameters.compositeHash was null or undefined when calling getMosaicRestrictionsMerkle.');
        }
        const queryParameters = {};
        const headerParameters = {};
        const response = await this.request({
            path: `/restrictions/mosaic/{compositeHash}/merkle`.replace(`{${"compositeHash"}}`, encodeURIComponent(String(requestParameters.compositeHash))),
            method: 'GET',
            headers: headerParameters,
            query: queryParameters,
        }, initOverrides);
        return new runtime.JSONApiResponse(response, (jsonValue) => MerkleStateInfoDTOFromJSON(jsonValue));
    }
    /**
     * Returns the mosaic restrictions merkle for a given composite hash.
     * Get the mosaic restrictions merkle
     */
    async getMosaicRestrictionsMerkle(requestParameters, initOverrides) {
        const response = await this.getMosaicRestrictionsMerkleRaw(requestParameters, initOverrides);
        return await response.value();
    }
    /**
     * Returns an array of mosaic restrictions.
     * Search mosaic restrictions
     */
    async searchMosaicRestrictionsRaw(requestParameters, initOverrides) {
        const queryParameters = {};
        if (requestParameters.mosaicId !== undefined) {
            queryParameters['mosaicId'] = requestParameters.mosaicId;
        }
        if (requestParameters.entryType !== undefined) {
            queryParameters['entryType'] = requestParameters.entryType;
        }
        if (requestParameters.targetAddress !== undefined) {
            queryParameters['targetAddress'] = requestParameters.targetAddress;
        }
        if (requestParameters.pageSize !== undefined) {
            queryParameters['pageSize'] = requestParameters.pageSize;
        }
        if (requestParameters.pageNumber !== undefined) {
            queryParameters['pageNumber'] = requestParameters.pageNumber;
        }
        if (requestParameters.offset !== undefined) {
            queryParameters['offset'] = requestParameters.offset;
        }
        if (requestParameters.order !== undefined) {
            queryParameters['order'] = requestParameters.order;
        }
        const headerParameters = {};
        const response = await this.request({
            path: `/restrictions/mosaic`,
            method: 'GET',
            headers: headerParameters,
            query: queryParameters,
        }, initOverrides);
        return new runtime.JSONApiResponse(response, (jsonValue) => MosaicRestrictionsPageFromJSON(jsonValue));
    }
    /**
     * Returns an array of mosaic restrictions.
     * Search mosaic restrictions
     */
    async searchMosaicRestrictions(requestParameters = {}, initOverrides) {
        const response = await this.searchMosaicRestrictionsRaw(requestParameters, initOverrides);
        return await response.value();
    }
}
