/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest
 *
 * The version of the OpenAPI document: 1.0.4
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AccountRestrictionFlagsEnum } from './AccountRestrictionFlagsEnum';
import { AliasActionEnum } from './AliasActionEnum';
import { CosignatureDTO } from './CosignatureDTO';
import { EmbeddedTransactionInfoDTO } from './EmbeddedTransactionInfoDTO';
import { LinkActionEnum } from './LinkActionEnum';
import { LockHashAlgorithmEnum } from './LockHashAlgorithmEnum';
import { MosaicRestrictionTypeEnum } from './MosaicRestrictionTypeEnum';
import { MosaicSupplyChangeActionEnum } from './MosaicSupplyChangeActionEnum';
import { NamespaceRegistrationTypeEnum } from './NamespaceRegistrationTypeEnum';
import { NetworkTypeEnum } from './NetworkTypeEnum';
import { TransactionTypeEnum } from './TransactionTypeEnum';
import { UnresolvedMosaic } from './UnresolvedMosaic';
/**
 *
 * @export
 * @interface TransactionInfoDTOTransaction
 */
export interface TransactionInfoDTOTransaction {
    /**
     * A number that allows uint 32 values.
     * @type {number}
     * @memberof TransactionInfoDTOTransaction
     */
    size: number;
    /**
     * Entity's signature generated by the signer.
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    signature: string;
    /**
     * Public key.
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    signerPublicKey: string;
    /**
     * Entity version.
     * @type {number}
     * @memberof TransactionInfoDTOTransaction
     */
    version: number;
    /**
     *
     * @type {NetworkTypeEnum}
     * @memberof TransactionInfoDTOTransaction
     */
    network: NetworkTypeEnum;
    /**
     *
     * @type {number}
     * @memberof TransactionInfoDTOTransaction
     */
    type: number;
    /**
     * Absolute amount. An amount of 123456789 (absolute) for a mosaic with divisibility 6 means 123.456789 (relative).
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    maxFee: string;
    /**
     * Duration expressed in number of blocks.
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    deadline: string;
    /**
     * 32 bytes voting public key.
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    linkedPublicKey: string;
    /**
     *
     * @type {LinkActionEnum}
     * @memberof TransactionInfoDTOTransaction
     */
    linkAction: LinkActionEnum;
    /**
     * Finalization Epoch
     * @type {number}
     * @memberof TransactionInfoDTOTransaction
     */
    startEpoch: number;
    /**
     * Finalization Epoch
     * @type {number}
     * @memberof TransactionInfoDTOTransaction
     */
    endEpoch: number;
    /**
     *
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    transactionsHash: string;
    /**
     * Array of transaction cosignatures.
     * @type {Array<CosignatureDTO>}
     * @memberof TransactionInfoDTOTransaction
     */
    cosignatures: Array<CosignatureDTO>;
    /**
     * Array of transactions initiated by different accounts.
     * @type {Array<EmbeddedTransactionInfoDTO>}
     * @memberof TransactionInfoDTOTransaction
     */
    transactions: Array<EmbeddedTransactionInfoDTO>;
    /**
     * Mosaic identifier. If the most significant bit of byte 0 is set, a namespaceId (alias)
     * is used instead of the real mosaic identifier.
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    mosaicId: string;
    /**
     * Absolute amount. An amount of 123456789 (absolute) for a mosaic with divisibility 6 means 123.456789 (relative).
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    amount: string;
    /**
     * Duration expressed in number of blocks.
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    duration: string;
    /**
     *
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    hash: string;
    /**
     * Address expressed in Base32 format. If the bit 0 of byte 0 is not set (like in 0x90), then it is a
     * regular address. Example: TAOXUJOTTW3W5XTBQMQEX3SQNA6MCUVGXLXR3TA.
     * Otherwise (e.g. 0x91) it represents a namespace id which starts at byte 1. Example: THBIMC3THGH5RUYAAAAAAAAAAAAAAAAAAAAAAAA
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    recipientAddress: string;
    /**
     *
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    secret: string;
    /**
     *
     * @type {LockHashAlgorithmEnum}
     * @memberof TransactionInfoDTOTransaction
     */
    hashAlgorithm: LockHashAlgorithmEnum;
    /**
     * Original random set of bytes.
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    proof: string;
    /**
     * Address expressed in Base32 format. If the bit 0 of byte 0 is not set (like in 0x90), then it is a
     * regular address. Example: TAOXUJOTTW3W5XTBQMQEX3SQNA6MCUVGXLXR3TA.
     * Otherwise (e.g. 0x91) it represents a namespace id which starts at byte 1. Example: THBIMC3THGH5RUYAAAAAAAAAAAAAAAAAAAAAAAA
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    targetAddress: string;
    /**
     * Metadata key scoped to source, target and type expressed.
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    scopedMetadataKey: string;
    /**
     * Change in value size in bytes.
     * @type {number}
     * @memberof TransactionInfoDTOTransaction
     */
    valueSizeDelta: number;
    /**
     * A number that allows uint 32 values.
     * @type {number}
     * @memberof TransactionInfoDTOTransaction
     */
    valueSize: number;
    /**
     * Metadata value. If embedded in a transaction, this is calculated as xor(previous-value, value).
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    value: string;
    /**
     * Mosaic identifier. If the most significant bit of byte 0 is set, a namespaceId (alias)
     * is used instead of the real mosaic identifier.
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    targetMosaicId: string;
    /**
     * Namespace identifier.
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    targetNamespaceId?: string;
    /**
     * Namespace identifier.
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    id: string;
    /**
     * A number that allows uint 32 values.
     * @type {number}
     * @memberof TransactionInfoDTOTransaction
     */
    nonce: number;
    /**
     * - 0x00 (none) - No flags present.
     * - 0x01 (supplyMutable) - Mosaic supports supply changes even when mosaic owner owns partial supply.
     * - 0x02 (transferable) - Mosaic supports transfers between arbitrary accounts. When not set, mosaic can only be transferred to and from mosaic owner.
     * - 0x04 (restrictable) - Mosaic supports custom restrictions configured by mosaic owner.
     * - 0x08 (revokable) - Mosaic allows creator to revoke balances from another user.
     * @type {number}
     * @memberof TransactionInfoDTOTransaction
     */
    flags: number;
    /**
     * Determines up to what decimal place the mosaic can be divided.
     * Divisibility of 3 means that a mosaic can be divided into smallest parts of 0.001 mosaics.
     * The divisibility must be in the range of 0 and 6.
     * @type {number}
     * @memberof TransactionInfoDTOTransaction
     */
    divisibility: number;
    /**
     * Absolute amount. An amount of 123456789 (absolute) for a mosaic with divisibility 6 means 123.456789 (relative).
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    delta: string;
    /**
     *
     * @type {MosaicSupplyChangeActionEnum}
     * @memberof TransactionInfoDTOTransaction
     */
    action: MosaicSupplyChangeActionEnum;
    /**
     * Address expressed in Base32 format. If the bit 0 of byte 0 is not set (like in 0x90), then it is a
     * regular address. Example: TAOXUJOTTW3W5XTBQMQEX3SQNA6MCUVGXLXR3TA.
     * Otherwise (e.g. 0x91) it represents a namespace id which starts at byte 1. Example: THBIMC3THGH5RUYAAAAAAAAAAAAAAAAAAAAAAAA
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    sourceAddress: string;
    /**
     * Namespace identifier.
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    parentId?: string;
    /**
     *
     * @type {NamespaceRegistrationTypeEnum}
     * @memberof TransactionInfoDTOTransaction
     */
    registrationType: NamespaceRegistrationTypeEnum;
    /**
     * Namespace name.
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    name: string;
    /**
     * Namespace identifier.
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    namespaceId: string;
    /**
     * Address encoded using a 32-character set.
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    address: string;
    /**
     *
     * @type {AliasActionEnum}
     * @memberof TransactionInfoDTOTransaction
     */
    aliasAction: AliasActionEnum;
    /**
     * Number of signatures needed to remove a cosignatory.
     * If we are modifying an existing multisig account, this indicates the relative change of the minimum cosignatories.
     * @type {number}
     * @memberof TransactionInfoDTOTransaction
     */
    minRemovalDelta: number;
    /**
     * Number of signatures needed to approve a transaction.
     * If we are modifying an existing multisig account, this indicates the relative change of the minimum cosignatories.
     * @type {number}
     * @memberof TransactionInfoDTOTransaction
     */
    minApprovalDelta: number;
    /**
     * Array of cosignatory accounts to add.
     * @type {Array<string>}
     * @memberof TransactionInfoDTOTransaction
     */
    addressAdditions: Array<string>;
    /**
     * Array of cosignatory accounts to delete.
     * @type {Array<string>}
     * @memberof TransactionInfoDTOTransaction
     */
    addressDeletions: Array<string>;
    /**
     *
     * @type {AccountRestrictionFlagsEnum}
     * @memberof TransactionInfoDTOTransaction
     */
    restrictionFlags: AccountRestrictionFlagsEnum;
    /**
     * Account restriction additions.
     * @type {Array<TransactionTypeEnum>}
     * @memberof TransactionInfoDTOTransaction
     */
    restrictionAdditions: Array<TransactionTypeEnum>;
    /**
     * Account restriction deletions.
     * @type {Array<TransactionTypeEnum>}
     * @memberof TransactionInfoDTOTransaction
     */
    restrictionDeletions: Array<TransactionTypeEnum>;
    /**
     * Mosaic identifier. If the most significant bit of byte 0 is set, a namespaceId (alias)
     * is used instead of the real mosaic identifier.
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    referenceMosaicId: string;
    /**
     * Restriction key.
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    restrictionKey: string;
    /**
     * Restriction value.
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    previousRestrictionValue: string;
    /**
     * Restriction value.
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    newRestrictionValue: string;
    /**
     *
     * @type {MosaicRestrictionTypeEnum}
     * @memberof TransactionInfoDTOTransaction
     */
    previousRestrictionType: MosaicRestrictionTypeEnum;
    /**
     *
     * @type {MosaicRestrictionTypeEnum}
     * @memberof TransactionInfoDTOTransaction
     */
    newRestrictionType: MosaicRestrictionTypeEnum;
    /**
     * Array of mosaics sent to the recipient.
     * @type {Array<UnresolvedMosaic>}
     * @memberof TransactionInfoDTOTransaction
     */
    mosaics: Array<UnresolvedMosaic>;
    /**
     * Transfer transaction message
     * @type {string}
     * @memberof TransactionInfoDTOTransaction
     */
    message?: string;
}
export declare function TransactionInfoDTOTransactionFromJSON(json: any): TransactionInfoDTOTransaction;
export declare function TransactionInfoDTOTransactionFromJSONTyped(json: any, ignoreDiscriminator: boolean): TransactionInfoDTOTransaction;
export declare function TransactionInfoDTOTransactionToJSON(value?: TransactionInfoDTOTransaction | null): any;
